\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{eskdsectext}[2017/08/23 v0.01 SectioningExt]

\newcommand{\ESKD@point@style}{single}

\DeclareOption{pointsingle}{\renewcommand{\ESKD@point@style}{single}}
\DeclareOption{pointsection}{\renewcommand{\ESKD@point@style}{section}}
\DeclareOption{pointsubsection}{\renewcommand{\ESKD@point@style}{subsection}}

\ProcessOptions\relax

\def\@startsection#1#2#3#4#5#6{%
  \if@noskipsec \leavevmode \fi
  \par
  \@tempskipa #4\relax
  \@afterindenttrue
  \ifdim \@tempskipa <\z@
    \@tempskipa -\@tempskipa \@afterindentfalse
  \fi
  \if@nobreak
    \everypar{}%
    \divide \@tempskipa by 2
    \vskip -\@tempskipa
    \vskip\z@skip
  \else
    \addpenalty\@secpenalty\addvspace\@tempskipa
  \fi
  \@ifstar
    {\@ssect{#3}{#4}{#5}{#6}}%
    {\@dblarg{\@sect{#1}{#2}{#3}{#4}{#5}{#6}}}}

\newcommand{\ESKDsectAlignLeft}{%
  \let\\\@centercr\@rightskip\@flushglue \rightskip\@rightskip%
  \leftskip\z@skip}
\newcommand{\ESKDsectAlignRight}{%
  \let\\\@centercr\rightskip\z@skip\leftskip\@flushglue
  \parindent\z@\parfillskip\z@skip}
\newcommand{\ESKDsectAlignCenter}{%
  \let\\\@centercr
  \rightskip\@flushglue\leftskip\@flushglue
  \parindent\z@\parfillskip\z@skip}

\newcommand{\ESKDchapterAlign}{\ESKDsectAlignLeft}
\newcommand{\ESKDsectionAlign}{\ESKDsectAlignLeft}
\newcommand{\ESKDsubsectionAlign}{\ESKDsectAlignLeft}
\newcommand{\ESKDsubsubsectionAlign}{\ESKDsectAlignLeft}

\newcommand{\ESKDparagraphAlign}{\ESKDsectAlignLeft}
\newcommand{\ESKDsubparagraphAlign}{\ESKDsectAlignLeft}

\newcommand{\ESKDsectAlign}[2]{%
  \expandafter\renewcommand\csname\string ESKD#1Align\endcsname{%
  \@nameuse{ESKDsectAlign#2}}}

\newcommand{\ESKDchapterStyle}{\normalfont\Large\bfseries\MakeUppercase}
\newcommand{\ESKDsectionStyle}{\normalfont\Large\bfseries}
\newcommand{\ESKDsubsectionStyle}{\normalfont\large\bfseries}
\newcommand{\ESKDsubsubsectionStyle}{\normalfont\normalsize\bfseries}
\newcommand{\ESKDparagraphStyle}{\normalfont\bfseries}
\newcommand{\ESKDsubparagraphStyle}{\normalfont\itshape}

\newcommand{\ESKDsectStyle}[2]{%
  \expandafter\renewcommand\csname\string ESKD#1Style\endcsname{#2}}

\newlength{\ESKDchapterSkipBefore}
\newlength{\ESKDchapterSkipAfter}
\setlength{\ESKDchapterSkipBefore}{-4ex}
\setlength{\ESKDchapterSkipAfter}{10pt}
\newlength{\ESKDsectionSkipBefore}
\newlength{\ESKDsectionSkipAfter}
\setlength{\ESKDsectionSkipBefore}{-3ex}
\setlength{\ESKDsectionSkipAfter}{8pt}
\newlength{\ESKDsubsectionSkipBefore}
\newlength{\ESKDsubsectionSkipAfter}
\setlength{\ESKDsubsectionSkipBefore}{-2ex}
\setlength{\ESKDsubsectionSkipAfter}{6pt}
\newlength{\ESKDsubsubsectionSkipBefore}
\newlength{\ESKDsubsubsectionSkipAfter}
\setlength{\ESKDsubsubsectionSkipBefore}{-2ex}
\setlength{\ESKDsubsubsectionSkipAfter}{6pt}
\newlength{\ESKDparagraphSkipBefore}
\newlength{\ESKDparagraphSkipAfter}
\setlength{\ESKDparagraphSkipBefore}{-1ex}
\setlength{\ESKDparagraphSkipAfter}{4pt}
\newlength{\ESKDsubparagraphSkipBefore}
\newlength{\ESKDsubparagraphSkipAfter}
\setlength{\ESKDsubparagraphSkipBefore}{-1ex}
\setlength{\ESKDsubparagraphSkipAfter}{1pt}

\providecommand{\plus}{\@plus}
\providecommand{\minus}{\@minus}

\newcommand{\ESKDsectSkip}[3]{%
  \expandafter\setlength\csname\string ESKD#1SkipBefore\endcsname{#2}%
  \expandafter\setlength\csname\string ESKD#1SkipAfter\endcsname{#3}}

\setcounter{secnumdepth}{3}

\newcommand\@sectheadparindent{\parindent}

\renewcommand\chapter{%
                      \if@openright\cleardoublepage\else\clearpage\fi%
                      \@startsection{chapter}{0}{\@sectheadparindent}%
                                   {\ESKDchapterSkipBefore}%
                                   {\ESKDchapterSkipAfter}%
                                   {\ESKDchapterAlign\ESKDchapterStyle}}
\renewcommand\section{\@startsection{section}{1}{\@sectheadparindent}%
                                    {\ESKDsectionSkipBefore}%
                                    {\ESKDsectionSkipAfter}%
                                    {\ESKDsectionAlign\ESKDsectionStyle}}
\renewcommand\subsection{\@startsection{subsection}{2}{\@sectheadparindent}%
                                     {\ESKDsubsectionSkipBefore}%
                                     {\ESKDsubsectionSkipAfter}%
                                     {\ESKDsubsectionAlign\ESKDsubsectionStyle}}
\renewcommand\subsubsection{\@startsection{subsubsection}{3}{\@sectheadparindent}%
                                     {\ESKDsubsubsectionSkipBefore}%
                                     {\ESKDsubsubsectionSkipAfter}%
                                     {\ESKDsubsubsectionAlign\ESKDsubsubsectionStyle}}
                                   
\renewcommand\paragraph{\@startsection{paragraph}{4}{\@sectheadparindent}%
  {\ESKDparagraphSkipBefore}%
  {\ESKDparagraphSkipAfter}%
  {\ESKDparagraphAlign\ESKDparagraphStyle}}

\renewcommand\subparagraph{\@startsection{subparagraph}{5}{\@sectheadparindent}%
  {\ESKDsubparagraphSkipBefore}%
  {\ESKDsubparagraphSkipAfter}%
  {\ESKDsubparagraphAlign\ESKDsubparagraphStyle}}

\renewcommand{\thechapter}{\arabic{chapter}}
\renewcommand{\thesection}{\thechapter.\arabic{section}}
\renewcommand{\thesubsection}{\thesection.\arabic{subsection}}
\renewcommand{\thesubsubsection}{\thesubsection.\arabic{subsubsection}}

\newif\ifESKD@point@style@single
\ESKD@point@style@singlefalse

\newcommand{\ESKD@point@style@single}{
  \newcounter{point}
  \renewcommand{\thepoint}{\arabic{point}}
  \newcommand{\theHpoint}{\arabic{point}}
  \ESKD@point@style@singletrue}

\newcommand{\ESKD@point@style@section}{
  \newcounter{point}[section]
  \renewcommand{\thepoint}{\thesection.\arabic{point}}
  \newcommand{\theHpoint}{\theHsection.\arabic{point}}}

\newcommand{\ESKD@point@style@subsection}{
  \newcounter{point}[subsection]
  \renewcommand{\thepoint}{\thesubsection.\arabic{point}}
  \newcommand{\theHpoint}{\theHsubsection.\arabic{point}}}

\@nameuse{ESKD@point@style@\ESKD@point@style}
\newcounter{subpoint}[point]
\newcounter{subsubpoint}[subpoint]
\renewcommand{\thesubpoint}{\thepoint.\arabic{subpoint}}
\newcommand{\theHsubpoint}{\theHpoint.\arabic{subpoint}}
\renewcommand{\thesubsubpoint}{\thesubpoint.\arabic{subsubpoint}}
\newcommand{\theHsubsubpoint}{\theHsubpoint.\arabic{subsubpoint}}

\newcommand{\point}{%
  \par\refstepcounter{point}\thepoint\quad}
\newcommand{\subpoint}{%
  \par\refstepcounter{subpoint}\thesubpoint\quad}
\newcommand{\subsubpoint}{%
  \par\refstepcounter{subsubpoint}\thesubsubpoint\quad}

\newcounter{appendix}
\renewcommand{\theappendix}{\Asbuk{appendix}}
\newlength{\ESKDappendixSkip}
\setlength{\ESKDappendixSkip}{15mm \@plus 3mm \@minus 10mm}

\newcommand{\ESKDappendix}[2]{%
  \ESKDclearDoublePage%
  \refstepcounter{appendix}%
  \setcounter{point}{0}%
  \ifESKD@point@style@single%
    \renewcommand{\thepoint}{\theappendix.\arabic{point}}%
  \fi
  \setcounter{section}{0}%
  \renewcommand{\thesection}{\theappendix.\arabic{section}}%
  \setcounter{equation}{0}%
  \renewcommand{\theequation}{\theappendix.\arabic{equation}}%
  \setcounter{figure}{0}%
  \renewcommand{\thefigure}{\theappendix.\arabic{figure}}%
  \setcounter{table}{0}%
  \renewcommand{\thetable}{\theappendix.\arabic{table}}%
  \addcontentsline{toc}{chapter}{\appendixname\ \theappendix\ #2}%
  \begin{list}{}{%
    \setlength{\itemindent}{0mm}%
    \setlength{\labelwidth}{0mm}%
    \setlength{\labelsep}{0mm}%
    \setlength{\leftmargin}{0mm}%
    \setlength{\topsep}{0mm}%
    \setlength{\parskip}{0mm}%
    \setlength{\partopsep}{0mm}%
    \setlength{\itemsep}{0mm}%
    \setlength{\parsep}{0mm}}
    \item\centering\appendixname\ \theappendix
    \ifx#1\@empty\else\\(#1)\fi\\
    \item\centering\bf #2
  \end{list}%
  \par\nobreak\addvspace{\ESKDappendixSkip}}

\renewcommand\tableofcontents{%
  \begingroup
  \ESKDsectAlign{chapter}{Center}
  \chapter*{\contentsname
    \@mkboth{%
      \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
  \endgroup
  \@starttoc{toc}}

